define([ "jquery", "base1/cockpit", "shell/shell", "shell/cockpit-main" ], function($, cockpit, shell) {
    "use strict";
    var _ = cockpit.gettext;
    var C_ = cockpit.gettext;
    PageMemoryStatus.prototype = {
        _init: function() {
            this.id = "memory_status";
        },
        getTitle: function() {
            return C_("page-title", "Memory");
        },
        enter: function() {
            this.client = shell.dbus(null);
            var resmon = this.client.get("/com/redhat/Cockpit/MemoryMonitor", "com.redhat.Cockpit.ResourceMonitor");
            var options = {
                series: {
                    shadowSize: 0,
                    lines: {
                        lineWidth: 0,
                        fill: true
                    }
                },
                yaxis: {
                    min: 0,
                    ticks: 5,
                    tickFormatter: function(v) {
                        return cockpit.format_bytes(v);
                    }
                },
                xaxis: {
                    show: true,
                    ticks: [ [ 0 * 60, "5 min" ], [ 1 * 60, "4 min" ], [ 2 * 60, "3 min" ], [ 3 * 60, "2 min" ], [ 4 * 60, "1 min" ] ]
                },
                x_rh_stack_graphs: true
            };
            this.plot = shell.setup_complicated_plot("#memory_status_graph", resmon, [ {
                color: "rgb(200,200,200)"
            }, {
                color: "rgb(150,150,150)"
            }, {
                color: "rgb(100,100,100)"
            }, {
                color: "rgb( 50, 50, 50)"
            } ], options);
        },
        show: function() {
            this.plot.start();
        },
        leave: function() {
            this.plot.destroy();
            this.client.release();
            this.client = null;
        }
    };
    function PageMemoryStatus() {
        this._init();
    }
    shell.pages.push(new PageMemoryStatus());
});